.\" $XConsortium: xkbcomp.man,v 1.1 94/04/11 11:54:29 erik Exp $
.TH XKBCOMP 1 "Release 6" "X Version 11"
.SH NAME
xkbcomp \- compile XKB keyboard description
.SH SYNOPSIS
.B xkbcomp
[-option ...] keymap-source
.SH DESCRIPTION
.PP
The
.I xkbcomp
keymap compiler converts a description of an XKB keymap into one of several
output formats.   The most common use for xkbcomp is to create a compiled
keymap file (.xkm extension) which can be read directly by XKB-capable X
servers or utilities.   The keymap compiler can also produce C header
files or XKB source files.  The C header files produced by xkbcomp can be
included by X servers or utilities that need a built-in default keymap.
The XKB source files produced by xkbcomp are fully resolved and can be 
used to verify that the files which typically make up an XKB keymap
are merged correctly or to create a single file which contains a complete
description of the keymap.
.SH OPTIONS
.TP 8
.B \-C
Produce a C header file as output (.h extension).
.TP 8
.B \-I\fIdir\fP
Specifies top-level directories to be searched for files included by the 
keymap description.
.TP 8
.B \-m\ \fIname\fP
Specifies a map to be compiled from an XKB directory file (not implemented yet).
.TP 8
.B \-o\ \fIname\fP
Specifies a name for the generated output file.  The default is the name of 
the source file with an appropriate extension for the output format.
.TP 8
.B \-w\ \fIlvl\fP
Controls the reporting of warnings during compilation.  A warning level 
of 0 disables all warnings; a warning level of 10 enables them all.
.TP 8
.B \-xkb
Generate a source description of the keyboard as output (.xkb extension).
.TP 8
.B \-xkm
Generate a compiled keymap file as output (.xkm extension).
.SH "SEE ALSO"
X(1)
.SH COPYRIGHT
Copyright 1994, Silicon Graphics Computer Systems and X Consortium, Inc.
.br
See \fIX(1)\fP for a full statement of rights and permissions.
.SH AUTHOR
Erik Fortune, Silicon Graphics
