.\" $XConsortium: xlsfonts.man,v 1.19 94/04/17 20:24:38 dpw Exp $
.\" Copyright (c) 1988  X Consortium
.\" 
.\" Permission is hereby granted, free of charge, to any person obtaining
.\" a copy of this software and associated documentation files (the
.\" "Software"), to deal in the Software without restriction, including
.\" without limitation the rights to use, copy, modify, merge, publish,
.\" distribute, sublicense, and/or sell copies of the Software, and to
.\" permit persons to whom the Software is furnished to do so, subject to
.\" the following conditions:
.\" 
.\" The above copyright notice and this permission notice shall be included
.\" in all copies or substantial portions of the Software.
.\" 
.\" THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
.\" OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
.\" MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
.\" IN NO EVENT SHALL THE X CONSORTIUM BE LIABLE FOR ANY CLAIM, DAMAGES OR
.\" OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
.\" ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
.\" OTHER DEALINGS IN THE SOFTWARE.
.\" 
.\" Except as contained in this notice, the name of the X Consortium shall
.\" not be used in advertising or otherwise to promote the sale, use or
.\" other dealings in this Software without prior written authorization
.\" from the X Consortium.
.TH XLSFONTS 1 "Release 6" "X Version 11"
.SH NAME
xlsfonts \- server font list displayer for X
.SH SYNOPSIS
.B xlsfonts
[\-options ...] [\-fn pattern]
.SH DESCRIPTION
.I Xlsfonts
lists the fonts that match the given \fIpattern\fP.
The wildcard character "*" may be used to match any sequence of
characters (including none), and "?" to match any single character.
If no pattern is given, "*" is assumed.
.PP
The "*" and "?" characters must be quoted to prevent them from
being expanded by the shell.
.SH "OPTIONS"
.PP
.TP 8
.B \-display \fIhost\fP:\fIdpy\fP
This option specifies the X server to contact.
.PP
.TP 8
.B \-l
Lists some attributes of the font on one line in addition to its name.
.TP 8
.B \-ll
Lists font properties in addition to \fB\-l\fP output.
.TP 8
.B \-lll
Lists character metrics in addition to \fB\-ll\fP output.
.TP 8
.B \-m
This option indicates that long listings should also print the minimum and
maximum bounds of each font.
.TP 8
.B \-C
This option indicates that listings should use multiple columns.  This is the
same as \fB\-n 0\fP.
.TP 8
.B \-1
This option indicates that listings should use a single column.  This is the
same as \fB\-n 1\fP.
.TP 8
.B \-w \fIwidth\fP
This option specifies the width in characters that should be used in 
figuring out how many columns to print.  The default is 79.
.TP 8
.B \-n \fIcolumns\fP
This option specifies the number of columns to use in displaying the output.
By default, it will attempt to fit as many columns of font names into the 
number of character specified by \fB\-w \fIwidth\fR.
.TP 8
.B \-u
This option indicates that the output should be left unsorted.
.TP 8
.B \-o
This option indicates that \fIxlsfonts\fP should do an \fBOpenFont\fP (and
\fBQueryFont\fP, if appropriate) rather than a \fBListFonts\fP.  This is
useful if \fBListFonts\fP or \fBListFontsWithInfo\fP fail to list a known
font (as is the case with some scaled font systems).
.TP 8
.B \-fn \fIpattern\fP
This option specifies the font name pattern to match.
.PP
.SH "SEE ALSO"
X(1), Xserver(1), xset(1), xfd(1),
.I "X Logical Font Description Conventions"
.SH ENVIRONMENT
.TP 8
.B DISPLAY
to get the default host and display to use.
.SH BUGS
Doing ``xlsfonts -l'' can tie up your server for a very long time.
This is really a bug with single-threaded non-preemptable servers, not with
this program.
.SH AUTHOR
Mark Lillibridge, MIT Project Athena; Jim Fulton, MIT X Consortium;
Phil Karlton, SGI
